<?php
/**
 * eXtreme Message Board
 * XMB 1.9.12
 *
 * Developed And Maintained By The XMB Group
 * Copyright (c) 2001-2020, The XMB Group
 * https://www.xmbforum2.com/
 * Arabic Translation By: Khamis Alqutob - http://XMBFORUM-AR.XYZ
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 **/

header( 'X-Frame-Options: deny' );

// Script constants
define('MYSQL_MIN_VER', '4.1.7');
define('PHP_MIN_VER', '7.0.0');
define('X_SCRIPT', 'upgrade.php');
define('ROOT', '../');
define('LOG_FILE', './upgrade.log');

// Check configuration
if (ini_get('display_errors')) {
	ini_set('display_errors', '0');
	$forced_display_off = TRUE;
} else {
	$forced_display_off = FALSE;
}

// Check location
if (!(is_file(ROOT.'header.php') && is_dir(ROOT.'include'))) {
    echo 'تعذر العثور على XMB-AR!<br />'
        .'يرجى التأكد من وجود مجلد الترقية في نفس المجلد مثل index.php و header.php.<br />';
    trigger_error('تمت محاولة الترقية بواسطة '.$_SERVER['REMOTE_ADDR'].' من موقع خاطئ.', E_USER_ERROR);
}

// Authenticate Browser
require(ROOT.'header.php');
echo "<html dir="rtl"><head><title>برمجية ترقية XMB-AR</title><body>تم تأسيس اتصال قاعدة البيانات<br />\n";
if (DEBUG) {
    echo 'تم تمكين وضع التصحيح.';
	if ($forced_display_off) {
		ini_set('display_errors', '1');
		trigger_error('خادم PHP الخاص بك لديه عرض الأخطاء display_errors=مفعل , التي لا ينبغي أن تستخدم في أنظمة الإنتاج.', E_USER_WARNING);
	}
} else {
    echo 'التصحيح تم تعيينه إلى خطأ - لن ترى أي أخطاء.';
}

if (!defined('X_SADMIN') || !X_SADMIN) {
    echo '<br /><br />هذه البرمجية قد تعمل فقط بواسطة مدير عام.<br />'
        .'من فضلك <a href="login.php">سجل دخولك</a> أولاً لبدء الترقية بنجاح.<br />';
    trigger_error('محاولة ترقية غير مصادق عليها بواسطة '.$_SERVER['REMOTE_ADDR'], E_USER_ERROR);
}

// Check Server Version
if (version_compare(phpversion(), PHP_MIN_VER, '<')) {
    echo '<br /><br />XMB يتطلب PHP الإصدار '.PHP_MIN_VER.' أو أعلى للعمل بشكل صحيح.  الإصدار '.phpversion().' يعمل حالياً.';
    trigger_error('المدير حاول الترقية باستخدام محرك PHP قديم.', E_USER_ERROR);
}
if (version_compare($db->server_version(), MYSQL_MIN_VER, '<')) {
    echo '<br /><br />XMB يتطلب MySQL الإصدار '.MYSQL_MIN_VER.' أو أعلى للعمل بشكل صحيح.  الإصدار '.$db->server_version().' يعمل حالياً.';
    trigger_error('المدير حاول الترقية باستخدام محرك MySQL قديم.', E_USER_ERROR);
}

// Initialize Verbose Logging
$result = file_put_contents( LOG_FILE, 'جاري تهيئة محرك الترقية...' );
if ( false === $result ) {
	echo '<br /><br />غير قادر على الكتابة إلى الملف ' . LOG_FILE . '. يرجى التحقق من أذونات دليل XMB-AR.';
	trigger_error( 'غير قادر على الكتابة إلى الملف ' . LOG_FILE, E_USER_ERROR );
}

// Ready to Upgrade
if (!isset($_GET['step']) || $_GET['step'] == 1) {
?>
<h1>برنامج ترقية XMB-AR 1.9.12</h1>

<p>هذا البرنامج  متوافق مع إصدارات XMB من 1.8 إلى 1.9.11 و XMB 1.9.12 للنسخ تحت التطوير.

<p>هذا البرنامج غير متوافق مع الإصدارات القديمة.

<h2>المقدمة</h2>
<ol>
<li>تعطيل المنتديات الخاصة بك باستخدام إعداد حالة المنتدى.
<li>احتفظ بنسخة احتياطية من قاعدة بياناتك - لا يمكن التراجع عن هذه البرمجية!
<li>تأكد من منح حساب قاعدة بيانات المنتدى الخاص بك أذونات ALTER, CREATE, INDEX, و LOCK .
<li>انسخ إعدادات config.php الخاصة بك إلى الملف الجديد.
<li>قم بتحميل ملفات XMB-AR 1.9.12. لا تقم بتحميل مجلد التثبيت install (احذفه إذا لزم الأمر).
<li>قم بتحميل دليل الترقية إلى الدليل الجذر لمنتداك.
<li>قم بتشغيل هذه البرمجية عن طريق الضغط على عنوان رابط الترقية ، على سبيل المثال:  https://www.example.com/forum/upgrade/
<li>عند انتهاء الترقية بنجاح ، احذف دليل الترقية.
<li>قم بتفعيل المنتديات الخاصة بك باستخدام إعداد حالة المنتدى.
</ol>

<form method="get" onsubmit="this.submit1.disabled=true; return true;">
<input type="hidden" name="step" value="2" />
<p>عندما تكون جاهزا, <input type="submit" value="انقر هنا إذا كان لديك بالفعل نسخة احتياطية وتريد بدء الترقية" id="submit1" />.
</form>
<?php

} else if ($_GET['step'] == 2) {

    ?>
    <h1>برنامج ترقية XMB-AR 1.9.12</h1>
    <h2>معلومات الحالة</h2>
    <?php

    ?>
	<iframe src='status.php' width='100%' height='50%'></iframe>
	<iframe src='trigger.php' width='100%'></iframe>
    <?php

}

echo "\n</body></html>";

?>