<?php
/**
 * eXtreme Message Board
 * XMB 1.9.12
 *
 * Developed And Maintained By The XMB Group
 * Copyright (c) 2001-2020, The XMB Group
 * https://www.xmbforum2.com/
 * Arabic Translation By: Khamis Alqutob - http://XMBFORUM-AR.XYZ
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 **/

ignore_user_abort( true );
header( 'Expires: 0' );
header( 'X-Frame-Options: sameorigin' );

//Script constants
define('MYSQL_MIN_VER', '4.1.7');
define('PHP_MIN_VER', '7.0.0');
define('X_SCRIPT', 'upgrade.php');
define('ROOT', '../');
define('LOG_FILE', './upgrade.log');

//Check configuration
if (ini_get('display_errors')) {
	ini_set('display_errors', '0');
	$forced_display_off = TRUE;
} else {
	$forced_display_off = FALSE;
}

//Check location
if (!(is_file(ROOT.'header.php') && is_dir(ROOT.'include'))) {
    show_error( 'تعذر العثور على XMB-AR!<br />يرجى التأكد من وجود مجلد الترقية في نفس المجلد مثل index.php و header.php.' );
    trigger_error('تمت محاولة الترقية بواسطة '.$_SERVER['REMOTE_ADDR'].' من موقع خاطئ.', E_USER_ERROR);
}

//Authenticate Browser
require(ROOT.'header.php');
echo "<html dir="rtl"><head><title>برمجية ترقية XMB-AR</title><body>تم تأسيس اتصال قاعدة البيانات<br />\n";
if (DEBUG) {
    echo 'تم تمكين وضع التصحيح.';
	if ($forced_display_off) {
		ini_set('display_errors', '1');
		trigger_error('خادم PHP الخاص بك لديه عرض الأخطاء display_errors=مفعل, التي لا ينبغي أن تستخدم في أنظمة الإنتاج.', E_USER_WARNING);
	}
} else {
    echo 'التصحيح تم تعيينه إلى خطأ - لن ترى أي أخطاء.';
}

if (!defined('X_SADMIN') || !X_SADMIN) {
    show_error( 'هذه البرمجية قد تعمل فقط بواسطة مدير عام.<br />من فضلك <a href="login.php" target="_parent">سجل دخولك</a> أولاً لبدء الترقية بنجاح.' );
    trigger_error('محاولة ترقية غير مصادق عليها بواسطة '.$_SERVER['REMOTE_ADDR'], E_USER_ERROR);
}

//Check Server Version
if (version_compare(phpversion(), PHP_MIN_VER, '<')) {
    show_error( 'XMB يتطلب PHP الإصدار '.PHP_MIN_VER.' أو أعلى للعمل بشكل صحيح.  الإصدار '.phpversion().' يعمل حالياً.' );
    trigger_error('المدير حاول الترقية باستخدام محرك PHP قديم.', E_USER_ERROR);
}
if (version_compare($db->server_version(), MYSQL_MIN_VER, '<')) {
    show_error( '<br /><br />XMB يتطلب MySQL الإصدار '.MYSQL_MIN_VER.' أو أعلى للعمل بشكل صحيح.  الإصدار '.$db->server_version().' يعمل حالياً.' );
    trigger_error('المدير حاول الترقية باستخدام محرك MySQL قديم.', E_USER_ERROR);
}


show_progress( 'تأكيد ملفات الترقية موجودة' );

if (is_dir(ROOT.'install') || is_dir(ROOT.'Install')) {
	show_error( 'توجد ملفات خاطئة !<br />يرجى حذف أي مجلدات مسماة "install".' );
	trigger_error('المدير حاول الترقية بينما كانت الملفات غير الخاصة بالترقية موجودة.', E_USER_ERROR);
}
if (!is_file(ROOT.'templates.xmb')) {
	show_error( 'الملفات مفقودة!<br />يرجى التأكد من تحميل ملف templates.xmb .' );
	trigger_error('المدير حاول الترقية باستخدام ملف templates.xmb مفقود.', E_USER_ERROR);
}
if (!is_file(ROOT.'lang/Arabic.lang.php')) {
	show_error( 'الملفات مفقودة!<br />يرجى التأكد من تحميل ملف lang/Arabic.lang.php .' );
	trigger_error('المدير حاول الترقية باستخدام ملف Arabic.lang.php مفقود.', E_USER_ERROR);
}
if (!is_file(ROOT.'include/schema.inc.php')) {
	show_error( 'الملفات مفقودة!<br />يرجى التأكد من تحميل ملف include/schema.inc.php .' );
	trigger_error('المدير حاول الترقية باستخدام ملف schema.lang.php مفقود.', E_USER_ERROR);
}
if (!is_file('./upgrade.lib.php')) {
	show_error( 'الملفات مفقودة!<br />يرجى التأكد من تحميل ملف upgrade/upgrade.lib.php .' );
	trigger_error('المدير حاول الترقية باستخدام ملف upgrade.lib.php مفقود.', E_USER_ERROR);
}

$trigger_old_schema = $SETTINGS['schema_version'];

require('./upgrade.lib.php');
xmb_upgrade();

if ( $trigger_old_schema < 5 ) {
    show_finished( '<b>تم ! :D</b><br />الآن <a href="../misc.php?action=login" target="_parent">قم بتسجيل الدخول وتذكر إعادة تشغيل المنتدى الخاص بك</a>.<br />' );
} else {
    show_finished( '<b>تم ! :D</b><br />الآن <a href="../cp.php?action=settings#1" target="_parent">قم بإعادة ضبط إعداد حالة المنتدى لإعادة تشغيل المنتديات الخاصة بك</a>.<br />' );
}
echo "\nتم .</body></html>";

/**
 * Output the upgrade progress at each step.
 *
 * This function is intended to be overridden by other upgrade scripts
 * that don't use this exact file, to support various output streams.
 *
 * @param string $text Description of current progress.
 */
function show_progress($text) {
	$result = file_put_contents( LOG_FILE, "\r\n$text...", FILE_APPEND );
	if ( false === $result ) {
		echo 'غير قادر على الكتابة إلى الملف ' . LOG_FILE;
		trigger_error( 'غير قادر على الكتابة إلى الملف ' . LOG_FILE, E_USER_ERROR );
	}
}

/**
 * Output a warning message to the user.
 *
 * @param string $text
 */
function show_warning($text) {
	$result = file_put_contents( LOG_FILE, "\r\n<b>$text</b>", FILE_APPEND );
	if ( false === $result ) {
		echo 'غير قادر على الكتابة إلى الملف ' . LOG_FILE;
		trigger_error( 'غير قادر على الكتابة إلى الملف ' . LOG_FILE, E_USER_ERROR );
	}
}

/**
 * Output an error message to the user.
 *
 * @param string $text Description of current progress.
 */
function show_error($text) {
    file_put_contents( LOG_FILE, "\r\n$text<!-- error -->", FILE_APPEND );
}

/**
 * Output final instructions to the user.
 *
 * @param string $text Description of current progress.
 */
function show_finished($text) {
    file_put_contents( LOG_FILE, "\r\n$text<!-- done. -->", FILE_APPEND );
}
?>